	
/******************************************************************
Scan 2D
******************************************************************/	
class Scan2D112 :UIFrame112
{
number Exposure
number PixelsX,PixelsY		//width and height of spectrum-image in pixels
number binX,binY			//binning of camera
number left,right,top,bottom	//coordinates of acquisition window
number width,height				//width and height of acquisition window

number SurveyID,cube4D_ID 	//IDs of images to find them out
number ROI_ID, ListID		//ID of spectrum-imaging ROI and its listener

number run

//standard names for parameters
string leftName,topName,widthName,heightName
string binXName,binYName
string PixelsXName,PixelsYName
string ExposureName


TagGroup CreateDialog(object self)
	{		
	TagGroup DialogAssign =DLGCreateDialog("").DLGTableLayout(2,2,0).DLGAnchor("West")
	
	DialogAssign.DLGAddElement(DLGCreatePushButton("Assign Image", "AssignImage").DLGIdentifier("ImageDeassigned").DLGAnchor("East"))
	DialogAssign.DLGAddElement(DLGCreatePushButton("Assign ROI", "AssignROI").DLGIdentifier("ROIDeassigned").DLGAnchor("East"))
	
		number Bcgrd =210
		number size =16
		image assigned :=self.GraphicFromString("V ",size,"",0,Bcgrd)
		assigned[0,0,size*3/4,size/2] =Bcgrd
	DialogAssign.DLGAddElement(DLGCreatePushButton("De-assign", "DeassignImage").DLGIdentifier("ImageAssigned").DLGAnchor("North"))
	DialogAssign.DLGAddElement(DLGCreatePushButton("De-assign","DeassignROI").DLGIdentifier("ROIAssigned").DLGAnchor("North"))
	
	TagGroup DialogSize =DLGCreateDialog("").DLGTableLayout(4,3,0).DLGAnchor("West")

	DialogSize.DLGAddElement(DLGcreateLabel(" ").DLGAnchor("East"))	
	DialogSize.DLGAddElement(DLGcreateLabel("Pixels").DLGAnchor("East"))
	DialogSize.DLGAddElement(DLGcreateLabel("Step(nm)").DLGAnchor("East"))
	DialogSize.DLGAddElement(DLGcreateLabel("Range(nm)").DLGAnchor("West"))
	
	DialogSize.DLGAddElement(DLGcreateLabel("X").DLGAnchor("East"))	
	DialogSize.DLGAddElement(DLGCreateIntegerField(20,5,"AreaChanged").DLGIdentifier("PixelsX").DLGAnchor("West"))
	DialogSize.DLGAddElement(DLGCreateRealField(0.5,8,5).DLGIdentifier("Step").DLGAnchor("East"))
	DialogSize.DLGAddElement(DLGCreateRealField(10,8,5).DLGIdentifier("RangeX").DLGAnchor("West"))

	DialogSize.DLGAddElement(DLGcreateLabel("Y").DLGAnchor("East"))	
	DialogSize.DLGAddElement(DLGCreateIntegerField(20,5).DLGIdentifier("PixelsY").DLGAnchor("West"))
	DialogSize.DLGAddElement(DLGcreateLabel("     ").DLGAnchor("East"))
	DialogSize.DLGAddElement(DLGCreateRealField(10,8,5).DLGIdentifier("RangeY").DLGAnchor("West"))	


	TagGroup DialogExposure =DLGCreateDialog("").DLGTableLayout(2,1,0).DLGAnchor("West")	

	DialogExposure.DLGAddElement(DLGcreateLabel("Pixel Time (s)"))		
	DialogExposure.DLGAddElement(DLGCreateRealField(0.5,8,5).DLGIdentifier(exposureName).DLGAnchor("East"))

	
	TagGroup DialogStart =DLGCreateDialog("").DLGTableLayout(4,1,0).DLGAnchor("West")		

	DialogStart.DLGAddElement(DLGCreatePushButton("  Start  ", "RunScanning").DLGIdentifier("Start").DLGAnchor("East"))
	DialogStart.DLGAddElement(DLGCreatePushButton("  Stop  ", "StopScanning").DLGIdentifier("Stop").DLGAnchor("East"))	
	DialogStart.DLGAddElement(DLGcreateLabel("    "))	
		size =20
	DialogStart.DLGAddElement(self.settingsButton(Size,Bcgrd,"Settings").DLGAnchor("East"))
	
	
	TagGroup Dialog =DLGCreateDialog("")

	Dialog.DLGAddElement(DialogAssign)
	Dialog.DLGAddElement(DialogSize)
	Dialog.DLGAddElement(DialogExposure)	
	Dialog.DLGAddElement(DialogStart)
	
	return Dialog
	}

void init(object self,string Package, string HeadName)
	{
	//names to store parameters
	leftName ="left"
	topName ="top"
	widthName ="width"
	heightName ="height"
	binXName ="binningX"
	binYName ="binningY"
	PixelsXName ="pixelsX"
	PixelsYName ="pixelsY"
	ExposureName ="dwellTime"

	//initialize UIFrame112
	self.initUIFrame112(self.CreateDialog(),Package,HeadName)

	//load displayed parameters
	Exposure =self.LoadNumber112(1,ExposureName)
	pixelsX =self.LoadNumber112(20,pixelsXName)
	pixelsY =self.LoadNumber112(20,pixelsYName)

result("\nDwell time "+Exposure+" binning "+binX+"x"+binY)
	
try{	//set dislayed parameters
	self.LookUpElement(ExposureName).DLGValue(Exposure)		
	self.LookUpElement("PixelsX").DLGValue(pixelsX)	
	self.LookUpElement("PixelsY").DLGValue(pixelsY)	

	self.SetElementIsEnabled("Stop",0)	
	self.SetElementIsEnabled("ImageAssigned",0)	
	self.SetElementIsEnabled("ROIAssigned",0)	
	}
catch{break;}

	//set unvisible settings parameters	
	top =self.LoadNumber112(896,topName)
	left =self.LoadNumber112(0,leftName)
	width =self.LoadNumber112(2048,widthName)
	height =self.LoadNumber112(256,heightName)
	binX =self.LoadNumber112(1,binXName)
	binY =self.LoadNumber112(1,binYName)
	
	right =left +width
	bottom =top +height
	
result("\ntop "+top+" left "+left+" bottom "+bottom+" right "+right +" width "+width+" height "+height)	
	}

void Settings(object self)
	{	
	number NumberLines = 6		//number of adjusted parameters
	
	TagGroup topT = DLGCreateIntegerField(top,6)
	TagGroup leftT = DLGCreateIntegerField(left,6)
	TagGroup widthT = DLGCreateIntegerField(width,6)
	TagGroup heightT = DLGCreateIntegerField(height,6)
	TagGroup binXT = DLGCreateIntegerField(binX,3)
	TagGroup binYT = DLGCreateIntegerField(binY,3)	
	
	//Compose DLG tags
	TagGroup SettingList = DLGCreateBox("Settings").DLGTableLayout(1,NumberLines,1)
	
	//SettingsLine is UIFrame112 
	SettingList.DLGaddElement(self.SettingsLine(topName,topT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(leftName,leftT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(widthName,widthT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(heightName,heightT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(binXName,binXT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(binYName,binYT).DLGAnchor("East"))	
		
	object SettingsFrame = Alloc(UIframe).init(SettingList)
	if(SettingsFrame.Pose())
		{
		top =self.SettingNumberParameter(topT,topName) 
		left =self.SettingNumberParameter(leftT,leftName) 
		width =self.SettingNumberParameter(widthT,topName) 
		height =self.SettingNumberParameter(heightT,topName) 	

		right =left +width
		bottom =top +height
	
		binX =self.SettingNumberParameter(binXT,binXName) 
		binY =self.SettingNumberParameter(binYT,binYName)	
		}
	}
	

//track changed spectrum-image area	
void AreaChanged(object self,number e_fl,ImageDisplay idisp,number r_fl,number r_fl2, ROI SIROI)
	{
	if(SIROI.ROIGetLabel()=="Spectrum Image")
		{
//result("\nchanged")
		image Survey :=SurveyID.getImageFromID()
		number scale,origin
		string units
		ImageGetDimensionCalibration(Survey,0,origin,scale,units,1)

		number top,left,bottom,right
		SIROI.ROIGetRectangle(top,left,bottom,right)
		
		//update range (in nm) fields
		number RangeX =(right-left)*scale 
		number RangeY =(bottom -top)*scale
		self.LookUpElement("RangeX").DLGValue(RangeX)	
		self.LookUpElement("RangeY").DLGValue(RangeY)	
		
		//update step (in nm) field
		pixelsX = self.LookUpElement("PixelsX").DLGgetValue()	
		number step =RangeX/pixelsX
		self.LookUpElement("Step").DLGValue(step)
		
		//update rangeY (in pixels) and step fields
		pixelsY =round(RangeY/step)
		self.LookUpElement("PixelsY").DLGValue(pixelsY)	
		}
	}

//track if PixelsX changed
void AreaChanged(object self,TagGroup tag)
	{
	ROI SIROI =GetROIFromID(ROI_ID)
	
	imageDisplay disp	//fictive display
	number e_f1,r_f1,r_f12	//fictive numbers
	if(SIROI.ROIisValid()) self.AreaChanged(e_f1,disp,r_f1,r_f12,SIROI)
	}
		
void AssignROI(object self)
	{		
	if(SurveyID!=0)	//check if image is assigned
		{
		image Survey :=SurveyID.getImageFromID()
		ImageDisplay Disp = Survey.ImageGetImageDisplay(0)
		
		//find rectangular ROI
		ROI SIROI 
		for(number i=0;i<Disp.ImageDisplayCountROIS();i++)
			{
			SIROI =Disp.ImageDisplayGetROI(i)
			if(SIROI.ROIIsRectangle()) break
			}		
		
		if(!SIROI.ROIIsValid()) 
			{
			OKdialog("Draw rectangular ROI first !!")
			exit(0)
			}
			
		ROI_ID= SIROI.ROIGetID()
result("\nROI_ID "+ROI_ID)

		//spectrum-image area appearance
		SIROI.ROISetColor(0,1,0)
		SIROI.ROISetVolatile(0)
		SIROI.ROISetLabel("Spectrum Image")
		
		//add listener to react the  changes in spectrum-image area
		ListID =Disp.ImageDisplayAddEventListener(self,"roi_changed:AreaChanged;roi_removed:ROIremoved") 
		
		//update fields
		number e_f1,r_f1,r_f12	//fictive numbers
		self.AreaChanged(e_f1,disp,r_f1,r_f12,SIROI)
		
		//update buttons
		self.SetElementIsEnabled("ROIDeassigned",0)
		self.SetElementIsEnabled("ROIAssigned",1)
		}
	else OKdialog("Assign Image first !!")	
	}
	
void DeassignROI(object self)
	{
	//update buttons
	self.SetElementIsEnabled("ROIDeassigned",1)
	self.SetElementIsEnabled("ROIAssigned",0)
	
	if(ROI_ID!=0)
		{
		image Survey :=SurveyID.getImageFromID()
		ImageDisplay Disp = Survey.ImageGetImageDisplay(0)
		
		//remove listener
		Disp.ImageDisplayRemoveEventListener(ListID)
		
		//restore standard ROI appearance
		ROI SIROI =GetROIFromID(ROI_ID)		
		SIROI.ROISetColor(1,0,0)
		SIROI.ROISetVolatile(1)
		SIROI.ROISetLabel("")
		}
		
	ROI_ID =0
	}

void ROIremoved(object self,number e_fl,ImageDisplay idisp,number r_fl,number r_fl2, ROI SIROI)
	{
	if(SIROI.ROIGetLabel()=="Spectrum Image")
		{
result("\nROI removed")
		ROI_ID =0
		
		self.DeassignROI()	
		}
	}
	
void AssignImage(object self)
	{
	image Survey :=getFrontImage()
	
	//check if it is digiscan image
	if(!checkSurveyImage112(Survey)) {OKdialog("Assigned image should be Digiscan !!");exit(0);}

	SurveyID =Survey.ImageGetID()
result("\nSurveyID "+SurveyID)

	//update buttons
	self.SetElementIsEnabled("ImageDeassigned",0)
	self.SetElementIsEnabled("ImageAssigned",1)
	}

void DeassignImage(object self)
	{
	//update buttons
	self.SetElementIsEnabled("ImageDeassigned",1)
	self.SetElementIsEnabled("ImageAssigned",0)
	
	self.DeassignROI()
		
	SurveyID =0
result("\nSurveyID "+SurveyID)
	}
	

number AboutToCloseUIFrame112( object self, number verify )
	{
	//store all parameters when UIFrame112 is closed
	Exposure =self.LookUpElement(ExposureName).DLGGetValue()
	PixelsX =self.LookUpElement("PixelsX").DLGGetValue()
	PixelsY =self.LookUpElement("PixelsY").DLGGetValue()
				
	self.StoreNumber112(Exposure,ExposureName)	
	self.StoreNumber112(PixelsX,PixelsXName)
	self.StoreNumber112(PixelsY,PixelsYName)
	self.StoreNumber112(binX,binXName)
	self.StoreNumber112(binY,binYName)
	self.StoreNumber112(top,topName)
	self.StoreNumber112(left,leftName)
	self.StoreNumber112(width,widthName)
	self.StoreNumber112(height,heightName)	

	//deassign spectrum-image area
	if(ROI_ID!=0) self.DeassignROI()
	
	return 1
	}
	
			
void Scanning(object self)
	{
	//check assignment
	image Survey 
	if(ROI_ID!=0)Survey :=SurveyID.getImageFromID()
	else {OKdialog("Assign image and ROI first !!");exit(0);}
	
	//update scanning parameters
	Exposure =self.LookUpElement(ExposureName).DLGgetValue()		
	pixelsX  =self.LookUpElement("PixelsX").DLGgetValue().round()	
	pixelsY  =self.LookUpElement("PixelsY").DLGgetValue().round()
result("\nExposure "+Exposure+"s Area "+pixelsX+"x"+PixelsY)	

	//get scanning area
	ROI SIROI =GetROIFromID(ROI_ID)
	number Xini,Xfin,Yini,Yfin
	SIROI.ROIGetRectangle(Yini,Xini,Yfin,Xfin)
result("\narea "+Xini+"-"+Xfin+" "+Yini+"-"+Yfin)

	//check the size of output images
	image current =AcquireCorrected112(0.01,binX,binY,top,left,bottom,right) 
	number binnedWidth,binnedHeight
	current.getSize(binnedWidth,binnedHeight)
result("\nbinned " +binnedWidth+"x"+binnedHeight)	
	current.setName("current image")
	
	//create beam marker
	ImageDisplay Disp = Survey.ImageGetImageDisplay(0)	
	ROI beam =newROI()
	beam.ROISetColor(1,0,0)
	beam.ROISetPoint(0,0)
	Disp.ImageDisplayAddROI(beam)
		
	//prepare output cube
	image cube :=realimage("data cube",4,binnedWidth,binnedHeight,PixelsX*PixelsY)	
	cube.showimage()

	//store size and calibration information
	number scaleX,scaleY,origin
	string units
	ImageGetDimensionCalibration(Survey,0,origin,scaleX,units,1)
	ImageGetDimensionCalibration(Survey,1,origin,scaleY,units,1)
result("\nscale "+scaleX+" "+scaleY)	
	scaleX *=(Xfin -Xini)/PixelsX
	scaleY *=(Yfin -Yini)/PixelsY
result("\nscale "+scaleX+" "+scaleY)	
	TagGroup ImTags = cube.ImageGetTagGroup()
	ImTags.TagGroupSetTagAsFloat("temDM:Scan2D"+":scaleX",scaleX)
	ImTags.TagGroupSetTagAsFloat("temDM:Scan2D"+":scaleY",scaleY)
	ImTags.TagGroupSetTagAsString("temDM:Scan2D"+":units",units)
	ImTags.TagGroupSetTagAsLong("temDM:Scan2D"+":pixelsX",pixelsX)
	ImTags.TagGroupSetTagAsLong("temDM:Scan2D"+":pixelsY",pixelsY)
	
result("\nrunning cumulative EELS")	
	current.showimage()
	
	try
	{
	number Xpos,Ypos
	for(number j=0;j<PixelsY;j++)
		{
		Ypos =Yini +j/(PixelsY-1)*(Yfin -Yini)
		
		for(number i=0;i<PixelsX;i++)
			{		
			Xpos =Xini +i/(PixelsX-1)*(Xfin -Xini)
result("\ni "+i+" j "+j+" position "+Xpos+" "+ Ypos)

			//position beam	
			Survey.PositionBeam112(Xpos,Ypos)
			
			//position beam marker
			beam.ROISetPoint(Xpos,Ypos) 
		
			//acquire image
			current =AcquireCorrected112(Exposure,binX,binY,top,left,bottom,right)
			
			//set in data cube
			cube[0,0,j*PixelsX+i,binnedWidth,binnedHeight,j*PixelsX+i+1] =current
			
			//check if not stopped by user
			self.CheckStopFlag(run,"Start")
			}
		}
	
	//remove beam marker 
	Disp.ImageDisplayDeleteROI(beam)	
	}
	catch 
		{
result("\nstopped or failed")
		//remove beam marker
		Disp.ImageDisplayDeleteROI(beam)
		
		break	
		}
	
result("\nfinished ")	
	self.TerminateThreadFromDLG(run,"Start","Stop")	
							//GLOBAL thread running number; start button IDENTIFIER; stop button IDENTIFIER
	}


void RunScanning( object self )
	{
	//fire thread
	self.RunThreadFromDLG("Scanning",run,"Start","Stop")
	}

void StopScanning(object self)
	{
	//stop thread
	self.StopThreadFromDLG(run,"Stop")
						//GLOBAL thread running number; stop button IDENTIFIER
	}		
	
	
}

//lunch scan 2D	 
{
//check if ExtendedFrames are loaded
if(!doesFunctionExist("LoadNumber112")) 
	{
	OKdialog("Please drop 'temDM extFrames.gt3' plugin in the plugins folder !!");
	exit(0);
	}
	
string Package = "_temDM-Scripts:Scan2D"
string HeadName = "Scan 2D"
alloc(Scan2D112).init(Package,HeadName);		
}
